import 'package:hakk_builder/hakk_builder.dart';

main(){

  //comment out the examples you don't want to see.

  helloWorld();
  stefan();
  medusa();
}

void medusa(){
  _header("Medusa - A larger Hakk that deploys 3 sub-hakks.  Doesn't do much else though.");
  print(
    hakk('Medusa', (){
      final mouse = 'mouse';
      blocks((){
        B.memory('mem2', 1, 0);
        B.memory('mem3', -1, 1);
        B.memory('mem4', 1, 1);
        B.memory('mem5', 0, 1);
        B.memory('mousemem', -1, 0);
        B.instruction(mouse, 0, 2);
        B.subHakkPort('shp1', 0, -2, 'sh1', (){
          B.shpBlock(mouse, 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
        B.subHakkPort('shp2', 0, -2, 'sh2', (){
          B.shpBlock(mouse, 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
        B.subHakkPort('shp3', 0, -2, 'sh3', (){
          B.shpBlock(mouse, 0, -1);
          B.shpBlock('mousemem', 0, -2);
        });
      });

      code((){
        codeBlock(mouse, (){
          I.rnd('mousemem.0', 100);
          I.jl('mousemem.0', 40, 'movef');
          I.jl('mousemem.0', 60, 'turnl');
          I.jl('mousemem.0', 80, 'turnr');
          I.goto('moveb');
          I.lbl('movef');
          I.rem('reading and writing from the main Hakk core memory');
          I.movef(core(7));
          I.movef(core(7));
          I.movef(core(7));
          I.goto(mouse);
          I.lbl('turnl');
          I.turn(core(6), 1);
          I.goto(mouse);
          I.lbl('turnr');
          I.turn(core(6), 0);
          I.goto(mouse);
          I.lbl('moveb');
          I.moveb(core(6));
          I.goto(mouse);
        });
        codeBlock('core', (){
          I.shpl(core(5), 'shp1');
          I.shpl(core(5), 'shp2');
          I.shpl(core(5), 'shp3');
          I.lbl('top');
          I.movef(core(0));
          I.je(core(0), 1, 'top');
          I.rem('move failed. move back a few spaces and change course');
          I.moveb(core(1));
          I.moveb(core(1));
          I.moveb(core(1));
          I.rnd(core(2), 2);
          I.rem('store the 0 or 1 in core.2 and then use it to change direction');
          I.turn(core(3), core(2));
          I.goto('top');
        });
      });
    })
  );
  _footer();
}

void stefan(){
  _header('Stefan - a small, offensive-minded hakk.');
  print(
    hakk('Stefan', (){
      blocks((){
        B.instruction('fight', 0, 1);
        B.staticInducer('slow', 1, 0);
        B.thermalInducer('heater', -1, 0);
      });
      code((){
        codeBlock('core', (){
          I.find();
          I.pop(core(0));
          I.pop(core(1));
          I.call('fight');
          I.movef(core(4));
          I.je(core(4), 1, 'main');
          I.moveb(core(4));
          I.moveb(core(4));
          I.moveb(core(4));
          I.rnd(core(2), 2);
          I.turn(core(3), core(2));
          I.goto('core');
        });
        codeBlock('fight', (){
          I.stat('slow', core(0), core(1));
          I.heat('heater', core(0), core(1));
          I.ret();
        });
      });
    })
  );
  _footer();
}

void helloWorld(){
  _header('Hello World');
  print(
    hakk('hello_world', (){
      blocks();
      code((){
        codeBlock('core', (){
          I.out('Hello World');
          I.exit(0);
        });
      });
    })
  );
  _footer();
}

void _header(String header){
  print('');
  print('');
  print(header);
  print('-------------------------------------------------');
}

void _footer(){
  print('-------------------------------------------------');
}