part of hakkit.hakk.builder;


void blocks([void body()]){
  _checkNotInCodeContext();
  _checkNotInBlockContext();
  _checkNotInCodeBlockContext();
  _checkNotInSHPContext();
  if (_blocksDeclared){
    _error('A hakkML file can only have a single section that declares blocks.');
  }
  _inBlocksContext = true;
  _hakkContext.write('blocks:$CR');
  _hakkContext.write('  - core:$CR');
  _blockNames.add('core');
  _memBlockNames.add('core');
  _instrBlockNames.add('core');
  _blocksDeclared = true;
  
  if (body != null){
    body();
  }

  _inBlocksContext = false;
}

/**
 * hakkML Blocks.
 */
class B
{
  static bool _firstShpBlock = true;

  static void memory(String name, int x, int y){
    _checkErrors(name);
    _memBlockNames.add(name);
    _writeBlock('mem', name, x, y);
  }

  static void instruction(String name, int x, int y){
    _checkErrors(name);
    _instrBlockNames.add(name);
    _writeBlock('instr', name, x, y);
  }

  static void thermalInducer(String name, int x, int y){
    _checkErrors(name);
    _thermalInducerNames.add(name);
    _writeBlock('ti', name, x, y);
  }

  static void staticInducer(String name, int x, int y){
    _checkErrors(name);
    _staticInducerNames.add(name);
    _writeBlock('si', name, x, y);
  }

  static void rebooter(String name, int x, int y){
    _checkErrors(name);
    _rebooterNames.add(name);
    _writeBlock('rebt', name, x, y);
  }

  static void heatSink(String name, int x, int y){
    _checkErrors(name);
    _heatSinkNames.add(name);
    _writeBlock('hsnk', name, x, y);
  }

  static void staticDischarger(String name, int x, int y){
    _checkErrors(name);
    _staticDischargerNames.add(name);
    _writeBlock('sdis', name, x, y);
  }

  static var _shBuff = new StringBuffer();
  static void subHakkPort(String name, int x, int y, String subHakkName, subHakk()){
    _checkErrors(name);
    _inSHPContext = true;
    _subHakkPortNames.add(name);
    subHakk();

    if(_shBuff.isEmpty){
      _error('No blocks for sub hakk defined.');
    }
    _hakkNames.add(subHakkName);
    final shString = _shBuff.toString().substring(0, _shBuff.toString().length - 2);
    _hakkContext.write('  - shp: {name: "$name", loc : [$x, $y], shname: "$subHakkName", blocks: {$shString}}$CR');
    _shBuff= new StringBuffer();
    _inSHPContext = false;
    _firstShpBlock = true;
  }

  static void shpBlock(String bName, int x, int y){
    _checkNotInCodeContext();
    _checkNotInCodeBlockContext();
    _checkInSHPContext();
    _checkInBlockContext();
    if (!_blockNames.contains(bName)){
      _error('A block should already be defined before declaring it for use in a sub-hakk', ctx: '$bName is not defined');
    }

    if (_firstShpBlock){
      if(!_instrBlockNames.contains(bName)){
        _error('The first block declared in an shp block list must be an instruction block.');
      }
      _firstShpBlock = false;
    }

    _shBuff.write('"$bName": [$x, $y], ');
  }

  static void _checkErrors(String name){
    _checkNotInCodeContext();
    _checkNotInCodeBlockContext();
    _checkNotInSHPContext();
    _checkInBlockContext();
    _checkBlockExists(name);
  }
}
